(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'moment', 'melon-core/InputComponent', 'melon-core/classname/cxBuilder', './util', 'melon/Icon', 'melon/Confirm', './timepicker/Panel', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('moment'), require('melon-core/InputComponent'), require('melon-core/classname/cxBuilder'), require('./util'), require('melon/Icon'), require('melon/Confirm'), require('./timepicker/Panel'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.moment, global.InputComponent, global.cxBuilder, global.util, global.Icon, global.Confirm, global.Panel, global.omit);
        global.index = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _moment, _InputComponent2, _cxBuilder, _util, _Icon, _Confirm, _Panel, _omit) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _moment2 = _interopRequireDefault(_moment);

    var _InputComponent3 = _interopRequireDefault(_InputComponent2);

    var Util = _interopRequireWildcard(_util);

    var _Icon2 = _interopRequireDefault(_Icon);

    var _Confirm2 = _interopRequireDefault(_Confirm);

    var _Panel2 = _interopRequireDefault(_Panel);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    var _get = function get(object, property, receiver) {
        if (object === null) object = Function.prototype;
        var desc = Object.getOwnPropertyDescriptor(object, property);

        if (desc === undefined) {
            var parent = Object.getPrototypeOf(object);

            if (parent === null) {
                return undefined;
            } else {
                return get(parent, property, receiver);
            }
        } else if ("value" in desc) {
            return desc.value;
        } else {
            var getter = desc.get;

            if (getter === undefined) {
                return undefined;
            }

            return getter.call(receiver);
        }
    };

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TimePicker');

    /**
     * melon/TimePicker
     *
     * @extends {React.Component}
     * @class
     */

    var TimePicker = function (_InputComponent) {
        _inherits(TimePicker, _InputComponent);

        /**
         * 构造函数
         *
         * @public
         * @constructor
         * @param {*} props 属性
         * @param {*} context 上下文
         */
        function TimePicker(props, context) {
            _classCallCheck(this, TimePicker);

            var _this = _possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props, context));

            var defaultValue = props.defaultValue,
                value = props.value,
                begin = props.begin,
                end = props.end;


            _this.onLabelClick = _this.onLabelClick.bind(_this);
            _this.onConfirm = _this.onConfirm.bind(_this);
            _this.onCancel = _this.onCancel.bind(_this);
            _this.onTimeChange = _this.onTimeChange.bind(_this);

            var time = value === void 0 ? defaultValue : value;

            var tiemObj = time && _this.parseValue(time);
            var beginObj = begin && _this.parseValue(begin);
            var endObj = end && _this.parseValue(end);

            /**
             * 初始状态
             *
             * @private
             * @type {Object}
             */
            _this.state = _extends({}, _this.state, {

                value: _this.stringifyValue(time && Util.closest(tiemObj, beginObj, endObj)),

                // 缓存用户在 confirm 前的选中值
                time: time ? _this.parseValue(Util.closest(tiemObj, beginObj, endObj)) : void 0,

                // 是否打开选择窗
                open: false
            });

            return _this;
        }

        /**
         * react生命周期，组件将更新时触发，用于value和date的同步
         *
         * @param {Object} _ 属性
         * @param {Object} nextState 状态
         */


        _createClass(TimePicker, [{
            key: 'componentWillUpdate',
            value: function componentWillUpdate(_, nextState) {
                var time = this.parseValue(nextState.value);
                if (this.state.value !== nextState.value && (time === void 0 || nextState.time === void 0 || !(0, _moment2.default)(time).isSame(nextState.time, 'minute') || !(0, _moment2.default)(time).isSame(nextState.time, 'hour'))) {
                    this.setState({
                        time: this.parseValue(nextState.value)
                    });
                }
            }
        }, {
            key: 'stringifyValue',
            value: function stringifyValue(time) {

                if (typeof time === 'string' || time == null) {
                    return time;
                }

                var timeFormat = this.props.timeFormat;

                return (0, _moment2.default)(time).format(timeFormat);
            }
        }, {
            key: 'parseValue',
            value: function parseValue(date) {

                if (typeof date !== 'string') {
                    return date;
                }

                return (0, _moment2.default)(date, this.props.timeFormat).toDate();
            }
        }, {
            key: 'onLabelClick',
            value: function onLabelClick() {

                this.setState({ open: true });

                var onFocus = this.props.onFocus;

                if (onFocus) {
                    onFocus({
                        type: 'focus',
                        target: this
                    });
                }
            }
        }, {
            key: 'onBlur',
            value: function onBlur() {

                var onBlur = this.props.onBlur;

                if (onBlur) {
                    onBlur({
                        type: 'blur',
                        target: this
                    });
                }
            }
        }, {
            key: 'onConfirm',
            value: function onConfirm() {
                var _this2 = this;

                var _state = this.state,
                    value = _state.value,
                    time = _state.time;


                value = this.parseValue(value);

                var valueMoment = (0, _moment2.default)(value, this.timeFormat);
                var timeMoment = (0, _moment2.default)(time);

                if (value !== '' && valueMoment.get('hour') === timeMoment.get('hour') && valueMoment.get('minute') === timeMoment.get('minute')) {
                    this.setState({ open: false });
                }

                this.setState({ open: false }, function () {

                    _get(TimePicker.prototype.__proto__ || Object.getPrototypeOf(TimePicker.prototype), 'onChange', _this2).call(_this2, {
                        type: 'change',
                        target: _this2,
                        value: _this2.stringifyValue(time)
                    });

                    _this2.onBlur();
                });
            }
        }, {
            key: 'onCancel',
            value: function onCancel() {
                var _this3 = this;

                this.setState({ open: false }, function () {
                    _this3.onBlur();
                });
            }
        }, {
            key: 'onTimeChange',
            value: function onTimeChange(_ref) {
                var time = _ref.time;

                this.setState({ time: time });
            }
        }, {
            key: 'renderHiddenInput',
            value: function renderHiddenInput() {
                var _props = this.props,
                    name = _props.name,
                    value = _props.value;


                return name ? _react2.default.createElement('input', {
                    name: name,
                    type: 'hidden',
                    value: value }) : null;
            }
        }, {
            key: 'render',
            value: function render() {
                var state = this.state,
                    props = this.props;

                var disabled = props.disabled,
                    readOnly = props.readOnly,
                    placeholder = props.placeholder,
                    timeFormat = props.timeFormat,
                    labelFormat = props.labelFormat,
                    others = _objectWithoutProperties(props, ['disabled', 'readOnly', 'placeholder', 'timeFormat', 'labelFormat']);

                var begin = props.begin,
                    end = props.end;


                begin = begin ? this.parseValue(begin) : null;
                end = end ? this.parseValue(end) : null;

                var value = state.value,
                    open = state.open;


                var className = cx(props).addStates({ focus: open }).addStates(this.getStyleStates()).build();

                return _react2.default.createElement(
                    'div',
                    _extends({}, (0, _omit2.default)(others, ['name']), { className: className }),
                    this.renderHiddenInput(),
                    _react2.default.createElement(
                        'label',
                        {
                            onClick: disabled || readOnly ? null : this.onLabelClick,
                            className: cx.getPartClassName('label') },
                        value ? (0, _moment2.default)(value, timeFormat).format(labelFormat) : _react2.default.createElement(
                            'span',
                            { className: cx.getPartClassName('label-placeholder') },
                            placeholder
                        ),
                        _react2.default.createElement(_Icon2.default, { icon: 'expand-more' })
                    ),
                    _react2.default.createElement(
                        _Confirm2.default,
                        {
                            open: open,
                            variants: ['timepicker'],
                            onConfirm: this.onConfirm,
                            onCancel: this.onCancel,
                            width: 'adaptive',
                            buttonVariants: ['secondery', 'timepicker'] },
                        _react2.default.createElement(_Panel2.default, {
                            time: this.state.time,
                            begin: begin,
                            end: end,
                            format: timeFormat,
                            onChange: this.onTimeChange })
                    )
                );
            }
        }]);

        return TimePicker;
    }(_InputComponent3.default);

    exports.default = TimePicker;


    TimePicker.displayName = 'TimePicker';

    TimePicker.defaultProps = _extends({}, _InputComponent3.default.defaultProps, {
        timeFormat: 'HH:mm:ss',
        labelFormat: 'HH:mm',
        placeholder: '请选择'
    });

    TimePicker.propTypes = _extends({}, _InputComponent3.default.propTypes, {
        placeholder: _propTypes2.default.string,
        timeFormat: _propTypes2.default.string,
        labalFormat: _propTypes2.default.string,
        end: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string]),
        begin: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string])
    });

    TimePicker.childContextTypes = _InputComponent3.default.childContextTypes;
    TimePicker.contextTypes = _InputComponent3.default.contextTypes;
});
//# sourceMappingURL=index.js.map
