(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'moment', 'melon-core/classname/cxBuilder', 'melon-core/util/array', 'melon/common/util/dom', '../util', './ClockItem', './ClockHand'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('moment'), require('melon-core/classname/cxBuilder'), require('melon-core/util/array'), require('melon/common/util/dom'), require('../util'), require('./ClockItem'), require('./ClockHand'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.moment, global.cxBuilder, global.array, global.dom, global.util, global.ClockItem, global.ClockHand);
        global.Clock = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _moment, _cxBuilder, _array, _dom, _util, _ClockItem, _ClockHand) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _moment2 = _interopRequireDefault(_moment);

    var Util = _interopRequireWildcard(_util);

    var _ClockItem2 = _interopRequireDefault(_ClockItem);

    var _ClockHand2 = _interopRequireDefault(_ClockHand);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TimePickerClock');
    var PI = Math.PI,
        atan = Math.atan;

    var TimePickerClock = function (_Component) {
        _inherits(TimePickerClock, _Component);

        /**
         * 构造函数
         *
         * @constructor
         * @public
         * @param  {*} props 组件属性
         */
        function TimePickerClock(props) {
            _classCallCheck(this, TimePickerClock);

            var _this = _possibleConstructorReturn(this, (TimePickerClock.__proto__ || Object.getPrototypeOf(TimePickerClock)).call(this, props));

            _this.onMouseDown = _this.onMouseDown.bind(_this);
            _this.onMouseUp = _this.onMouseUp.bind(_this);
            _this.onMouseChange = _this.onMouseChange.bind(_this);
            return _this;
        }

        /**
         * react 组件生命周期——判断是否需要更新组件，用来做性能优化
         *
         * @public
         * @override
         * @param {Object} nextProps 更新的属性
         * @return {boolean} 是否需要更新
         */


        _createClass(TimePickerClock, [{
            key: 'shouldComponentUpdate',
            value: function shouldComponentUpdate(nextProps) {
                var _props = this.props,
                    time = _props.time,
                    mode = _props.mode,
                    begin = _props.begin,
                    end = _props.end;


                return !Util.isSame(time, nextProps.time) || mode !== nextProps.mode || !(0, _moment2.default)(begin).isSame(nextProps.begin) || !(0, _moment2.default)(end).isSame(nextProps.end);
            }
        }, {
            key: 'onMouseDown',
            value: function onMouseDown(e) {
                if (this.props.mode === 'minute') {
                    this.refs.main.addEventListener('mousemove', this.onMouseChange);
                    document.addEventListener('mouseup', this.onMouseUp);
                } else {
                    this.refs.main.addEventListener('mouseup', this.onMouseChange);
                }
            }
        }, {
            key: 'onMouseUp',
            value: function onMouseUp(e) {

                if (this.props.mode === 'minute') {
                    this.onMouseChange(e);
                    this.refs.main.removeEventListener('mousemove', this.onMouseChange);
                    document.removeEventListener('mouseup', this.onMouseUp);
                } else {
                    this.refs.main.removeEventListener('mouseup', this.onMouseChange);
                }
            }
        }, {
            key: 'onMouseChange',
            value: function onMouseChange(_ref) {
                var pageX = _ref.pageX,
                    pageY = _ref.pageY;


                var mainPosition = (0, _dom.getPosition)(this.refs.main);
                var radius = mainPosition.width / 2;

                var pos = {
                    x: pageX - mainPosition.left - radius,
                    y: pageY - mainPosition.top - radius
                };

                var deg = void 0;

                if (pos.y === 0) {
                    return;
                }

                if (pos.x >= 0 && pos.y < 0) {
                    deg = -180 * atan(pos.x / pos.y) / PI;
                } else if (pos.x >= 0 && pos.y > 0) {
                    deg = 180 - 180 * atan(pos.x / pos.y) / PI;
                } else if (pos.x < 0 && pos.y > 0) {
                    deg = 180 - 180 * atan(pos.x / pos.y) / PI;
                } else if (pos.x < 0 && pos.y < 0) {
                    deg = 360 - 180 * atan(pos.x / pos.y) / PI;
                }

                var _props2 = this.props,
                    time = _props2.time,
                    mode = _props2.mode,
                    begin = _props2.begin,
                    end = _props2.end;


                var single = mode === 'minute' ? 6 : 30;
                var number = Math.round(deg / single);

                if (mode === 'hour') {
                    // number为0表示选择了上午12点
                    number = number === 0 ? 12 : number;
                    // 下午的时间加12
                    number = time.getHours() > 12 ? number + 12 : number;
                    // number为24时的特殊处理，日期如果不改为0，日期会加1
                    number = number === 24 ? 0 : number;
                } else if (mode === 'minute') {
                    number = number === 60 ? 0 : number;
                }

                var newTime = (0, _moment2.default)(time)[mode](number).toDate();

                if (Util.isSame(newTime, time) || !Util.isBetween(newTime, begin, end)) {
                    return;
                }

                this.props.onChange({
                    time: newTime
                });
            }
        }, {
            key: 'renderItems',
            value: function renderItems() {
                var _props3 = this.props,
                    time = _props3.time,
                    mode = _props3.mode,
                    begin = _props3.begin,
                    end = _props3.end;


                var items = mode === 'hour' ? (0, _array.range)(1, 13) : (0, _array.range)(0, 60, 5);

                return items.map(function (number) {

                    var timeMoment = void 0;
                    var selected = false;
                    if (mode === 'hour') {
                        var hour = (0, _moment2.default)(time).hour();
                        hour = hour === 0 ? 24 : hour;
                        selected = (hour > 12 ? hour - 12 : hour) === number;
                        var itemHour = hour > 12 ? number + 12 : number;
                        timeMoment = (0, _moment2.default)(time).hour(itemHour);
                    } else {
                        selected = (0, _moment2.default)(time).minute() === number;
                        timeMoment = (0, _moment2.default)(time).minute(number);
                    }

                    var itemTime = timeMoment.toDate();

                    return _react2.default.createElement(_ClockItem2.default, {
                        key: mode + number,
                        time: itemTime,
                        mode: mode,
                        selected: selected,
                        disabled: !Util.isBetween(itemTime, begin, end) });
                });
            }
        }, {
            key: 'render',
            value: function render() {
                var _props4 = this.props,
                    time = _props4.time,
                    mode = _props4.mode,
                    onChange = _props4.onChange;


                var className = cx(this.props).addVariants(mode).build();

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    _react2.default.createElement(
                        'div',
                        {
                            className: cx.getPartClassName('main'),
                            ref: 'main',
                            onMouseDown: this.onMouseDown },
                        _react2.default.createElement(_ClockHand2.default, {
                            time: time,
                            mode: mode,
                            onChange: onChange }),
                        this.renderItems()
                    )
                );
            }
        }]);

        return TimePickerClock;
    }(_react.Component);

    exports.default = TimePickerClock;


    TimePickerClock.displayName = 'TimePickerClock';

    TimePickerClock.propTypes = {
        time: _propTypes2.default.instanceOf(Date),
        mode: _propTypes2.default.oneOf(['hour', 'minute']),
        begin: _propTypes2.default.instanceOf(Date),
        end: _propTypes2.default.instanceOf(Date),
        onChange: _propTypes2.default.func.isRequired
    };
});
//# sourceMappingURL=Clock.js.map
