(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'moment', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('moment'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.moment, global.cxBuilder);
        global.ClockHand = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _moment, _cxBuilder) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _moment2 = _interopRequireDefault(_moment);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _defineProperty(obj, key, value) {
        if (key in obj) {
            Object.defineProperty(obj, key, {
                value: value,
                enumerable: true,
                configurable: true,
                writable: true
            });
        } else {
            obj[key] = value;
        }

        return obj;
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TimePickerClockHand');

    /**
     * melon/TimePickerClockHand
     *
     * @extends {React.Component}
     * @class
     */

    var TimePickerClockHand = function (_Component) {
        _inherits(TimePickerClockHand, _Component);

        function TimePickerClockHand() {
            _classCallCheck(this, TimePickerClockHand);

            return _possibleConstructorReturn(this, (TimePickerClockHand.__proto__ || Object.getPrototypeOf(TimePickerClockHand)).apply(this, arguments));
        }

        _createClass(TimePickerClockHand, [{
            key: 'getStyle',
            value: function getStyle() {
                var _props = this.props,
                    time = _props.time,
                    mode = _props.mode;


                var number = (0, _moment2.default)(time)[mode]();
                var single = mode === 'minute' ? 6 : 30;
                var deg = (180 + single * number) % 360;

                return ['Webkit', 'Moz', 'ms', ''].reduce(function (result, prefix) {

                    return _extends({}, result, _defineProperty({}, '' + prefix + (prefix ? 'T' : 't') + 'ransform', 'translate(-50%, 0) rotate(' + deg + 'deg)'));
                }, {});
            }
        }, {
            key: 'render',
            value: function render() {
                var _props2 = this.props,
                    time = _props2.time,
                    mode = _props2.mode;


                var className = cx(this.props).addVariants(mode === 'minute' && (0, _moment2.default)(time).minute() % 5 !== 0 ? 'end' : null).build();

                return _react2.default.createElement(
                    'div',
                    { className: className, style: this.getStyle() },
                    _react2.default.createElement('div', { className: cx.getPartClassName('end') })
                );
            }
        }]);

        return TimePickerClockHand;
    }(_react.Component);

    exports.default = TimePickerClockHand;


    TimePickerClockHand.displayName = 'TimePickerClockHand';

    TimePickerClockHand.propTypes = {
        time: _propTypes2.default.instanceOf(Date).isRequired,
        mode: _propTypes2.default.oneOf(['hour', 'minute']).isRequired
    };
});
//# sourceMappingURL=ClockHand.js.map
