(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'moment', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('moment'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.moment, global.cxBuilder);
        global.Header = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _moment, _cxBuilder) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _moment2 = _interopRequireDefault(_moment);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TimePickerHeader');

    /**
     * melon/TimePickerHeader
     *
     * @extends {React.Component}
     * @class
     */

    var TimePickerHeader = function (_Component) {
        _inherits(TimePickerHeader, _Component);

        function TimePickerHeader() {
            _classCallCheck(this, TimePickerHeader);

            return _possibleConstructorReturn(this, (TimePickerHeader.__proto__ || Object.getPrototypeOf(TimePickerHeader)).apply(this, arguments));
        }

        _createClass(TimePickerHeader, [{
            key: 'render',
            value: function render() {

                var props = this.props;

                var time = props.time,
                    mode = props.mode;

                var timeMoment = (0, _moment2.default)(time);

                var selected = mode === 'hour';

                var hour = (0, _moment2.default)(time).hour();
                var isAfternoon = false;

                if (hour > 12 || hour === 0) {
                    isAfternoon = true;
                }

                return _react2.default.createElement(
                    'div',
                    { className: cx(props).build() },
                    _react2.default.createElement(
                        'div',
                        { className: cx.getPartClassName('time') },
                        _react2.default.createElement(
                            'span',
                            {
                                onClick: selected && props.onModeChange ? null : function () {
                                    props.onModeChange({ mode: 'hour' });
                                },
                                className: cx().part('time-hour').addStates({ selected: selected }).build() },
                            timeMoment.format('HH')
                        ),
                        _react2.default.createElement(
                            'span',
                            null,
                            ':'
                        ),
                        _react2.default.createElement(
                            'span',
                            {
                                onClick: !selected && props.onModeChange ? null : function () {
                                    props.onModeChange({ mode: 'minute' });
                                },
                                className: cx().part('time-minute').addStates({ selected: !selected }).build() },
                            timeMoment.format('mm')
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: cx.getPartClassName('apm') },
                        _react2.default.createElement(
                            'span',
                            {
                                onClick: !isAfternoon && props.onChange ? null : function () {
                                    props.onChange({ time: (0, _moment2.default)(time).subtract(12, 'h').toDate() });
                                },
                                className: cx().part('apm-am').addStates({ selected: !isAfternoon }).build() },
                            'AM'
                        ),
                        _react2.default.createElement(
                            'span',
                            {
                                onClick: isAfternoon && props.onChange ? null : function () {
                                    props.onChange({ time: (0, _moment2.default)(time).add(12, 'h').toDate() });
                                },
                                className: cx().part('apm-pm').addStates({ selected: isAfternoon }).build() },
                            'PM'
                        )
                    )
                );
            }
        }]);

        return TimePickerHeader;
    }(_react.Component);

    exports.default = TimePickerHeader;


    TimePickerHeader.displayName = 'TimePickerHeader';

    TimePickerHeader.defaultProps = {
        time: (0, _moment2.default)().millisecond(0).seconds(0).toDate(),
        mode: 'hour'
    };

    TimePickerHeader.propTypes = {
        time: _propTypes2.default.instanceOf(Date),
        mode: _propTypes2.default.oneOf(['hour', 'minute']),
        onModeChange: _propTypes2.default.func
    };
});
//# sourceMappingURL=Header.js.map
